diff -u -r --new-file os-prober-1.77.orig/common.sh os-prober-1.77/common.sh
--- os-prober-1.77.orig/common.sh	2018-08-10 14:23:18.000000000 -0500
+++ os-prober-1.77/common.sh	2019-08-05 23:39:13.130356299 -0500
@@ -4,6 +4,10 @@
 
 cleanup_tmpdir=false
 cleanup () {
+  local partition
+  for partition in $cleanup_ro_partitions; do
+    blockdev --setrw "$partition"
+  done
   if $cleanup_tmpdir; then
     rm -rf "$OS_PROBER_TMP"
   fi
@@ -176,6 +180,15 @@
 		sed 's/\\011/	/g; s/\\012/\n/g; s/\\040/ /g; s/\\134/\\/g'
 }
 
+ro_partition () {
+	if type blockdev >/dev/null 2>&1 && \
+	   [ "$(blockdev --getro "$1")" = 0 ] && \
+	   blockdev --setro "$1"; then
+		cleanup_ro_partitions="${cleanup_ro_partitions:+$cleanup_ro_partitions }$1"
+		trap cleanup EXIT HUP INT QUIT TERM
+	fi
+}
+
 find_label () {
 	local output
 	if type blkid >/dev/null 2>&1; then
diff -u -r --new-file os-prober-1.77.orig/os-probes/common/50mounted-tests os-prober-1.77/os-probes/common/50mounted-tests
--- os-prober-1.77.orig/os-probes/common/50mounted-tests	2018-08-10 14:23:18.000000000 -0500
+++ os-prober-1.77/os-probes/common/50mounted-tests	2019-08-05 23:37:24.763351672 -0500
@@ -69,6 +69,15 @@
 		debug "mounted using GRUB, but unknown filesystem?"
 		type=fuseblk
 	fi
+else
+	ro_partition "$partition"
+	for type in $types $delaytypes; do
+		if mount -o ro -t "$type" "$partition" "$tmpmnt" 2>/dev/null; then
+			debug "mounted as $type filesystem"
+			mounted=1
+			break
+		fi
+	done
 fi
 
 if [ "$mounted" ]; then
